Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Class Similarity

    java.lang.Object
      org.apache.lucene.search.Similarity

Direct Known Subclasses:
  DefaultSimilarity

public abstract class Similarity
extends Object

Expert: Scoring API.

Subclasses implement search scoring.

The score of query `q` for document `d` is defined in terms of these methods as follows:

score(q,d) = | Σ | `tf`(t in d) * `idf`(t) * `getBoost`(t.field in d) * `lengthNorm`(t.field in d) | * `coord`(q,d) * `queryNorm`(q)
t in q

See Also:
  `setDefault(Similarity)`, `IndexWriter.setSimilarity(Similarity)`, `Searcher.setSimilarity(Similarity)`

Constructor Summary
`Similarity()`

Method Summary
`abstract float` | `coord(int overlap, int maxOverlap)` Computes a score factor based on the fraction of all query terms that a document contains.
`static float` | `decodeNorm(byte b)` Decodes a normalization factor stored in an index.
`static byte` | `encodeNorm(float f)` Encodes a normalization factor for storage in an index.
`static Similarity` | `getDefault()` Return the default Similarity implementation used by indexing and search code.
`float` | `idf(Collection terms, Searcher searcher)` Computes a score factor for a phrase.
`abstract float` | `idf(int docFreq, int numDocs)` Computes a score factor based on a term's document frequency (the number of documents which contain the term).
`float` | `idf(Term term, Searcher searcher)` Computes a score factor for a simple term.
`abstract float` | `lengthNorm(String fieldName, int numTokens)` Computes the normalization value for a field given the total number of terms contained in a field.
`abstract float` | `queryNorm(float sumOfSquaredWeights)` Computes the normalization value for a query given the sum of the squared weights of each of the query terms.
`static void` | `setDefault(Similarity similarity)` Set the default Similarity implementation used by indexing and search code.
`abstract float` | `sloppyFreq(int distance)` Computes the amount of a sloppy phrase match, based on an edit distance.
`abstract float` | `tf(float freq)` Computes a score factor based on a term or phrase's frequency in a document.
`float` | `tf(int freq)` Computes a score factor based on a term or phrase's frequency in a document.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Similarity

    public Similarity()

Method Detail

### setDefault

    public static void setDefault(Similarity similarity)

  Set the default Similarity implementation used by indexing and search code.

  See Also:
    `Searcher.setSimilarity(Similarity)`, `IndexWriter.setSimilarity(Similarity)`

### getDefault

    public static Similarity getDefault()

  Return the default Similarity implementation used by indexing and search code.

  This is initially an instance of `DefaultSimilarity`.

  See Also:
    `Searcher.setSimilarity(Similarity)`, `IndexWriter.setSimilarity(Similarity)`

### decodeNorm

    public static float decodeNorm(byte b)

  Decodes a normalization factor stored in an index.

  See Also:
    `encodeNorm(float)`

### lengthNorm

    public abstract float lengthNorm(String fieldName,
                                     int numTokens)

  Computes the normalization value for a field given the total number of terms contained in a field. These values, together with field boosts, are stored in an index and multipled into scores for hits on each field by the search code.

  Matches in longer fields are less precise, so implemenations of this method usually return smaller values when `numTokens` is large, and larger values when `numTokens` is small.

  That these values are computed under `IndexWriter.addDocument(Document)` and stored then using {#encodeNorm(float)}. Thus they have limited precision, and documents must be re-indexed if this method is altered.

  Parameters:
    `fieldName` - the name of the field
    `numTokens` - the total number of tokens contained in fields named fieldName of doc.
  Returns:
    a normalization factor for hits on this field of this document
  See Also:
    `Field.setBoost(float)`

### queryNorm

    public abstract float queryNorm(float sumOfSquaredWeights)

  Computes the normalization value for a query given the sum of the squared weights of each of the query terms. This value is then multipled into the weight of each query term.

  This does not affect ranking, but rather just attempts to make scores from different queries comparable.

  Parameters:
    `sumOfSquaredWeights` - the sum of the squares of query term weights
  Returns:
    a normalization factor for query weights

### encodeNorm

    public static byte encodeNorm(float f)

  Encodes a normalization factor for storage in an index.

  The encoding uses a five-bit exponent and three-bit mantissa, thus representing values from around 7x10^9 to 2x10^-9 with about one significant decimal digit of accuracy. Zero is also represented. Negative numbers are rounded up to zero. Values too large to represent are rounded down to the largest representable value. Positive values too small to represent are rounded up to the smallest positive representable value.

  See Also:
    `Field.setBoost(float)`

### tf

    public float tf(int freq)

  Computes a score factor based on a term or phrase's frequency in a document. This value is multiplied by the `idf(Term, Searcher)` factor for each term in the query and these products are then summed to form the initial score for a document.

  Terms and phrases repeated in a document indicate the topic of the document, so implementations of this method usually return larger values when `freq` is large, and smaller values when `freq` is small.

  The default implementation calls `tf(float)`.

  Parameters:
    `freq` - the frequency of a term within a document
  Returns:
    a score factor based on a term's within-document frequency

### sloppyFreq

    public abstract float sloppyFreq(int distance)

  Computes the amount of a sloppy phrase match, based on an edit distance. This value is summed for each sloppy phrase match in a document to form the frequency that is passed to `tf(float)`.

  A phrase match with a small edit distance to a document passage more closely matches the document, so implementations of this method usually return larger values when the edit distance is small and smaller values when it is large.

  Parameters:
    `distance` - the edit distance of this sloppy phrase match
  Returns:
    the frequency increment for this match
  See Also:
    `PhraseQuery.setSlop(int)`

### tf

    public abstract float tf(float freq)

  Computes a score factor based on a term or phrase's frequency in a document. This value is multiplied by the `idf(Term, Searcher)` factor for each term in the query and these products are then summed to form the initial score for a document.

  Terms and phrases repeated in a document indicate the topic of the document, so implemenations of this method usually return larger values when `freq` is large, and smaller values when `freq` is small.

  Parameters:
    `freq` - the frequency of a term within a document
  Returns:
    a score factor based on a term's within-document frequency

### idf

    public float idf(Term term,
                     Searcher searcher)
              throws IOException

  Computes a score factor for a simple term.

  The default implementation is:

         return idf(searcher.docFreq(term), searcher.maxDoc());

  Note that `Searchable.maxDoc()` is used instead of `IndexReader.numDocs()` because it is proportional to `Searchable.docFreq(Term)` , i.e., when one is inaccurate, so is the other, and in the same direction.

  Parameters:
    `term` - the term in question
    `searcher` - the document collection being searched
  Returns:
    a score factor for the term
  Throws:
    `IOException`

### idf

    public float idf(Collection terms,
                     Searcher searcher)
              throws IOException

  Computes a score factor for a phrase.

  The default implementation sums the `idf(Term,Searcher)` factor for each term in the phrase.

  Parameters:
    `terms` - the terms in the phrase
    `searcher` - the document collection being searched
  Returns:
    a score factor for the phrase
  Throws:
    `IOException`

### idf

    public abstract float idf(int docFreq,
                              int numDocs)

  Computes a score factor based on a term's document frequency (the number of documents which contain the term). This value is multiplied by the `tf(int)` factor for each term in the query and these products are then summed to form the initial score for a document.

  Terms that occur in fewer documents are better indicators of topic, so implemenations of this method usually return larger values for rare terms, and smaller values for common terms.

  Parameters:
    `docFreq` - the number of documents which contain the term
    `numDocs` - the total number of documents in the collection
  Returns:
    a score factor based on the term's document frequency

### coord

    public abstract float coord(int overlap,
                                int maxOverlap)

  Computes a score factor based on the fraction of all query terms that a document contains. This value is multiplied into scores.

  The presence of a large portion of the query terms indicates a better match with the query, so implemenations of this method usually return larger values when the ratio between these parameters is large and smaller values when the ratio between them is small.

  Parameters:
    `overlap` - the number of query terms matched in the document
    `maxOverlap` - the total number of terms in the query
  Returns:
    a score factor based on term overlap with the query

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2005 Apache Software Foundation. All Rights Reserved.